//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"

class X68kIODevice;

class AreaSetDevice : public IODevice
{
	using inherited = IODevice;

	static const int baseaddr = 0xe86000;

 public:
	AreaSetDevice();
	~AreaSetDevice() override;

	bool Init() override;
	void ResetHard(bool poweron) override;

	busdata Read8(uint32 addr) override;
	busdata Read16(uint32 addr) override;
	busdata Write8(uint32 addr, uint32 data) override;
	busdata Write16(uint32 addr, uint32 data) override;
	busdata Peek8(uint32 addr) override;

 private:
	X68kIODevice *x68kio {};
};
