//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// GVRAM
//

#pragma once

#include "device.h"

class GVRAMDevice : public IODevice
{
	using inherited = IODevice;
	static const uint baseaddr = 0xc0'0000;
 public:
	GVRAMDevice();
	~GVRAMDevice() override;

	busdata Read8(uint32 addr) override;
	busdata Read16(uint32 addr) override;
	busdata Write8(uint32 addr, uint32 data) override;
	busdata Write16(uint32 addr, uint32 data) override;
	busdata Peek8(uint32 addr) override;

 private:
	std::unique_ptr<uint8[]> mem {};
};
