//
// nono
// Copyright (C) 2024 nono project
// Licensed under nono-license.txt
//

//
// VM (virt68k)
//

#include "vm_virt68k.h"
#include "config.h"
#include "mainbus_virt68k.h"
#include "mpu680x0.h"
#include "power.h"
#include "renderer.h"

// コンストラクタ
VM_Virt68k::VM_Virt68k()
	: inherited("virt-m68k")
{
	// 機種固有パラメータ
	gConfig->SetDefault("mpu-clock", 25);
	// RAM 初期値。適当。
	gConfig->SetDefault("ram-size", 128);

	// デバイス
	NEWDV(Power, new PowerDevice());
	NEWDV(MPU, new MPU680x0Device());
	NEWDV(Mainbus, new Virt68kMainbus());
	NEWDV(Renderer, new NopRenderer());

	// バーストアクセス有効にする
	dynamic_cast<MPU680x0Device*>(pMPU.get())->EnableBurstAccess(true);
}

// デストラクタ
VM_Virt68k::~VM_Virt68k()
{
}
